# # Self-elevate the script if required
# if (-Not ([Security.Principal.WindowsPrincipal] [Security.Principal.WindowsIdentity]::GetCurrent()).IsInRole([Security.Principal.WindowsBuiltInRole] 'Administrator')) {
#     if ([int](Get-CimInstance -Class Win32_OperatingSystem | Select-Object -ExpandProperty BuildNumber) -ge 6000) {
#         $CommandLine = "-File `"" + $MyInvocation.MyCommand.Path + "`" " + $MyInvocation.UnboundArguments
#         Start-Process -FilePath PowerShell.exe -Verb Runas -ArgumentList $CommandLine
#         Exit
#     }
# }


# User Profile
Write-Host "User Profile Directory: $($env:USERPROFILE)"

# VS Code Directory
$app_data = $env:APPDATA
Write-Host "VS Code User Directory: $($app_data)\Code\User"

$vscode_user_settings_path = "$($app_data)\Code\User\settings.json"
Write-Host "VS Code User Settings Path: $($vscode_user_settings_path)"

# Cmder Config Directory
$cmder_root = $env:CMDER_ROOT
Write-Host "Cmder Config Directory: $($cmder_root)\config"

$cmder_user_conemu_xml_path = "$($cmder_root)\config\user_ConEmu.xml"
Write-Host "Cmder ConEmu Path: $($cmder_user_conemu_xml_path)"

$cmder_user_profile_cmd_path = "$($cmder_root)\config\user_profile.cmd"
Write-Host "Cmder CMD User Profile Path: $($cmder_user_profile_cmd_path)"

$cmder_user_aliases_cmd_path = "$($cmder_root)\config\user_aliases.cmd"
Write-Host "Cmder CMD Aliases Path: $($cmder_user_aliases_cmd_path)"

$cmder_user_profile_ps_path = "$($cmder_root)\config\user_profile.ps1"
Write-Host "Cmder PowerShell Profile Path: $($cmder_user_profile_ps_path)"

# Neovim Config Directory
$local_app_data = $env:LOCALAPPDATA
Write-Host "Neovim Init Directory: $($local_app_data)\nvim"

$neovim_init_path = "$($local_app_data)\nvim\init.vim"
Write-Host "Neovim Init Path: $($neovim_init_path)"

# Cmder DOSKEY Aliases
if (-not (Test-Path -Path $cmder_user_aliases_cmd_path)) {
    $repo_cmder_user_aliases_cmd_path = "$($PWD)\cmder\user_aliases.cmd" 
    Write-Host "Repo user_aliases.cmd: $($repo_cmder_user_aliases_cmd_path)"
    New-Item -Path $cmder_user_aliases_cmd_path -ItemType SymbolicLink -Value $repo_cmder_user_aliases_cmd_path
    Get-Item -Path $cmder_user_aliases_cmd_path
} else {
    Write-Host "Cmder User Aliases Exists"
}

# Cmder CMD Profile
if (-not (Test-Path -Path $cmder_user_profile_cmd_path)) {
    $repo_cmder_user_profile_cmd_path = "$($PWD)\cmder\user_aliases.cmd"
    Write-Host "Repo user_profile.cmd: $($repo_cmder_user_profile_cmd_path)"
    New-Item -Path $cmder_user_profile_cmd_path -ItemType SymbolicLink -Value $repo_cmder_user_profile_cmd_path
    Get-Item -Path $cmder_user_profile_cmd_path
} else {
    Write-Host "Cmder User Profile Exists"
}

# Cmder Powershell User Profile
if (-not (Test-Path -Path $cmder_user_profile_ps_path)) {
    $repo_cmder_user_profile_ps_path = "$($PWD)\cmder\user_profile.ps1"
    Write-Host "Repo user_profile.ps1: $($repo_cmder_user_profile_ps_path)"
    New-Item -Path $cmder_user_profile_ps_path -ItemType SymbolicLink -Value $repo_cmder_user_profile_ps_path
    Get-Item -Path $cmder_user_profile_ps_path
} else {
    Write-Host "Cmder Powershell Profile Exists"
}

# Cmder ConEmu Settings
if(-not (Test-Path -Path $cmder_user_conemu_xml_path)) {
    $repo_cmder_user_conemu_cml_path = "$($PWD)\cmder\user-ConEmu.xml"
    Write-Host "Repo user-ConEmu.xml: $($repo_cmder_user_conemu_cml_path)"
    New-Item -Path $cmder_user_conemu_xml_path -ItemType SymbolicLink -Value $repo_cmder_user_conemu_cml_path
} else {
    Write-Host "Cmder ConEum User Profile Exists"
}

# VSCODE Settings
if (-not (Test-Path -Path $vscode_user_settings_path)) {
    $repo_vscode_user_settings_path = "$($PWD)\vscode\settings.json)"
    Write-Host "Repo VSCode User Settings: $($repo_vscode_user_settings_path)"
    New-Item -Path $vscode_user_settings_path -ItemType SymbolicLink -Value $repo_vscode_user_settings_path
    Get-Item -Path $vscode_user_settings_path
} else {
    Write-Host "VS Code User Settings Exists"
}

# NeoVim init
if (-not (Test-Path -Path $neovim_init_path)) {
    $repo_neovim_init_path = "$($PWD)\vim\init.vim"
    Write-Host "Repo init.vim: $($repo_neovim_init_path)"
    New-Item -Path $neovim_init_path -ItemType SymbolicLink -Value $repo_neovim_init_path
    Get-Item -Path $neovim_init_path
} else {
    Write-Host "Neovim Init Path Exists"
}

Write-Host -NoNewline "Press any key to continue.."
$null = $Host.UI.RawUI.ReadKey("NoEcho,IncludeKeyDown")